<?php
require("../../config.php");
require_once("$CFG->dirroot/local/badiunet/lib/util.php");
require_once("$CFG->dirroot/local/badiunet/lib/netlib.php");
require_once("$CFG->dirroot/local/badiunet/lib/httpquerystring.php");
require_once("$CFG->dirroot/local/badiunet/fcservice/maccess.php");
require_once("$CFG->dirroot/local/badiunet/fcservice/factorycontent.php");

new local_badiunet_remote_auth();


class local_badiunet_remote_auth {
    private $requesttoken=null;
    private $username=null;
    private $urltarget=null;
    function __construct() {
          $this->exec();
    }
    
    function exec() {
		exit;
        //validate text token 
       $this->validateToken();
        //verify token online
        $this->checkRemote();
        //auth user
        $this->execLogin();
    }
    
    function printContent($content) {
        global $PAGE,$OUTPUT;
         $context = context_system::instance();
        $PAGE->set_context($context);
        $PAGE->set_url('/local/badiunet/fcservice/index.php');
        $PAGE->set_pagelayout('standard');
        $PAGE->set_title('Badiu.Net');
        $PAGE->set_heading('Badiu.Net');
        
        echo $OUTPUT->header();
        echo $content;
        echo $OUTPUT->footer();
        exit;
    }
        
    function validateToken(){
        $msg=null;
        $this->requesttoken=optional_param('_tokenauth',null,PARAM_TEXT); 
       if(empty($this->requesttoken)){$msg='Token remoto vazio';}
       else if(strlen($this->requesttoken)<120){$msg='Token remoto invalido';}
       if(!empty($msg)){$this->printContent($msg); }
    }
    
    function checkRemote(){
        $httpqs=new local_badiunet_httpquerystring();
        $httpqs->add('_key','badiu.moodle.core.lib.datautil');
        $httpqs->add('_kfunction','remoteAccessAuth'); 
        $httpqs->add('_tokenauth',$this->requesttoken);
        
        $factorycontent=new local_badiunet_factorycontent('notformated');
       
        $httpqs->add('sservicid',$factorycontent->getNetlib()->getModuleInstance()); 
        $factorycontent->setService('badiu.system.core.functionality.exec.service');
        $uparam=$httpqs->getParam();
       
        $factorycontent->setParamsytemdefault($uparam);
        $factorycontent->init();
        $response=$factorycontent->getContent();
    
        if(!$factorycontent->getUtil()->isResponseError($response)){
            $message=$factorycontent->getUtil()->getVlueOfArray($response, 'message');
            $status= $factorycontent->getUtil()->getVlueOfArray($response, 'status');
            $message=$factorycontent->getTcript()->decode($message);   
            if($status=='accept' && !empty($message)){ 
                $this->username=$factorycontent->getUtil()->getVlueOfArray($message, 'username');    
                $this->urltarget=$factorycontent->getUtil()->getVlueOfArray($message, 'urltarget');
             }
          
        }else{
            $this->printContent('Remote access failed');  
        }
       
    } 
     function execLogin(){
         if(empty($this->username)){
            $this->printContent('Username get by webservice is empty');   
         }
         global  $DB,$CFG;
         $user = $DB->get_record('user', array('username'=>$this->username));
         if(empty($user) || empty($user->id)){
              $this->printContent('Username get by webservice is not valid');
         }
         $resultath=complete_user_login($user);
         if(empty($resultath)){ $this->printContent('Login failed');}
         
         if(empty($this->urltarget)){$this->urltarget='';}
         redirect($CFG->httpswwwroot.$this->urltarget);
         exit;
     }
        
   
    function getRequesttoken() {
        return $this->requesttoken;
    }

    function getUsername() {
        return $this->username;
    }

    function getUrltarget() {
        return $this->urltarget;
    }

    function setRequesttoken($requesttoken) {
        $this->requesttoken = $requesttoken;
    }

    function setUsername($username) {
        $this->username = $username;
    }

    function setUrltarget($urltarget) {
        $this->urltarget = $urltarget;
    }


}

?>
